<template>
  <canvas ref="canvas" :style="{ width, height }" />
</template>

<script lang="ts">
import { Component, Ref, Vue } from "nuxt-property-decorator";

import { LobbyRoomLevel } from "~/../server/contracts/lobbyroom-level.enum";
import { NeonColor } from "~/../server/contracts/neon-color.enum";
import { ServiceRoomType } from "~/../server/contracts/serviceroom-type.enum";
import { SpecialRoomType } from "~/../server/contracts/specialroom-type.enum";

@Component
export default class GameCanvas extends Vue {
  @Ref()
  readonly canvas!: HTMLCanvasElement;

  width: number = 680;

  height: number = 520;

  async mounted() {
    const { Game } = await import("../assets/scripts/Game");
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const game = new Game({
      vue: this,
      view: this.canvas,
      width: this.width,
      height: this.height,
      resources: {
        spritesNearest: "sprites_nearest.json",
        spritesLinear: "sprites_linear.json"
      },
      fonts: {
        default: "Estrangelo Edessa",
        hotelTitle: "Adam Gorry Inline",
        hotelRoomTitle: "Gill Sans MT Condensed",
        hotelClock: "Minisystem"
      },
      // TODO: use generated seed from backend
      seed: btoa((Math.random() * 1000) + ";" + (Math.random() * 1000) + ";" + (Math.random() * 1000000)),
      hotel: {
        id: 1,
        name: "Un nom d'hôtel très long !!!".toUpperCase(),
        playerId: "5d9bac23-b2a7-4ea8-ba49-83d60728c642",
        updatedAt: new Date(),
        stars: 3,
        money: 200,
        fame: 20,
        neonColor: NeonColor.yellow,
        level: 1,
        createdAt: new Date(2021, 8, 14),
        floors: [
          {
            id: 5,
            hotelId: 1,
            level: 0,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 14),
            updatedAt: new Date(),
            rooms: [
              {
                id: 16,
                floorId: 1,
                position: 1,
                type: "empty",
                createdAt: new Date(2021, 8, 14, 3, 8, 2, 12),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 14,
                floorId: 1,
                position: 2,
                type: "special",
                service: SpecialRoomType.LAB,
                serviceEndAt: new Date(2022, 1, 1),
                progress: 0.75,
                createdAt: new Date(2021, 8, 14, 4, 2, 13, 43),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 10,
                floorId: 1,
                position: 3,
                type: "lobby",
                level: LobbyRoomLevel.THREE,
                createdAt: new Date(2021, 8, 14, 3, 8, 2, 12),
                updatedAt: new Date(),
                isBuilt: true
              }
            ]
          },
          {
            id: 9,
            hotelId: 1,
            level: 1,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 14, 5, 6, 7, 24),
            updatedAt: new Date(),
            rooms: [
              {
                id: 18,
                floorId: 2,
                position: 1,
                type: "bed",
                level: 1,
                createdAt: new Date(2021, 8, 14, 5, 20, 45, 35),
                updatedAt: new Date(),
                buildingEndAt: new Date(2021, 12, 31, 4, 23, 32, 12)
              },
              {
                id: 20,
                floorId: 2,
                position: 2,
                type: "special",
                service: SpecialRoomType.RESTAURANT,
                createdAt: new Date(2021, 8, 14, 6, 12, 13, 98),
                updatedAt: new Date(),
                buildingEndAt: new Date(2021, 12, 31, 6, 12, 16, 54)
              },
              {
                id: 22,
                floorId: 2,
                position: 3,
                type: "bed",
                level: 2,
                createdAt: new Date(2021, 8, 14, 5, 46, 12, 4),
                updatedAt: new Date(),
                buildingEndAt: new Date(2021, 12, 31, 13, 2, 34, 42)
              }
            ]
          },
          {
            id: 16,
            hotelId: 1,
            level: 2,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 14, 5, 22, 45, 53),
            updatedAt: new Date(),
            rooms: [
              {
                id: 23,
                floorId: 2,
                position: 0,
                type: "special",
                service: SpecialRoomType.DISCO,
                createdAt: new Date(2021, 8, 14, 5, 23, 2, 19),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 35,
                floorId: 2,
                position: 1,
                type: "bed",
                level: 2,
                createdAt: new Date(2021, 8, 14, 5, 32, 1, 1),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 38,
                floorId: 2,
                position: 2,
                type: "bed",
                level: 3,
                createdAt: new Date(2021, 8, 14, 8, 3, 26, 13),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 45,
                floorId: 2,
                position: 3,
                type: "service",
                service: ServiceRoomType.WASH,
                createdAt: new Date(2021, 8, 16, 10, 56, 6, 46),
                updatedAt: new Date(),
                isBuilt: true,
                serviceEndAt: new Date(2022, 1, 1)
              },
              {
                id: 69,
                floorId: 2,
                position: 4,
                type: "service",
                service: ServiceRoomType.SHOE,
                createdAt: new Date(2021, 9, 22, 43, 12, 43, 52),
                updatedAt: new Date(),
                isBuilt: true,
                serviceEndAt: new Date(2022, 1, 1)
              },
              {
                id: 76,
                floorId: 2,
                position: 5,
                type: "service",
                service: ServiceRoomType.FRIDGE,
                createdAt: new Date(2021, 9, 29, 23, 12, 56, 42),
                updatedAt: new Date(),
                isBuilt: true,
                serviceEndAt: new Date(2022, 1, 1)
              }
            ]
          },
          {
            id: 25,
            hotelId: 1,
            level: 3,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 16, 10, 27, 45, 9),
            updatedAt: new Date(),
            rooms: [
              {
                id: 123,
                floorId: 3,
                position: 2,
                type: "service",
                service: ServiceRoomType.ALCOOL,
                createdAt: new Date(2021, 9, 19, 2, 23, 12, 56),
                updatedAt: new Date(),
                isBuilt: true,
                serviceEndAt: new Date(2022, 1, 1)
              },
              {
                id: 157,
                floorId: 3,
                position: 3,
                type: "special",
                service: SpecialRoomType.FURNACE,
                createdAt: new Date(2021, 8, 16, 10, 27, 45, 46),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 198,
                floorId: 3,
                position: 4,
                type: "bed",
                level: 2,
                createdAt: new Date(2021, 8, 17, 8, 13, 7, 57),
                updatedAt: new Date(),
                isBuilt: true
              }
            ]
          },
          {
            id: 42,
            hotelId: 1,
            level: 4,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 19, 1, 56, 43, 22),
            updatedAt: new Date(),
            rooms: [
              {
                id: 220,
                floorId: 4,
                position: 1,
                type: "bed",
                level: 1,
                createdAt: new Date(2021, 8, 19, 1, 56, 43, 78),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 264,
                floorId: 4,
                position: 2,
                type: "bed",
                level: 2,
                createdAt: new Date(2021, 8, 19, 8, 13, 43, 41),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 365,
                floorId: 4,
                position: 3,
                type: "bed",
                level: 1,
                createdAt: new Date(2021, 8, 22, 5, 34, 10, 91),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 378,
                floorId: 4,
                position: 4,
                type: "special",
                service: SpecialRoomType.BIN,
                createdAt: new Date(2021, 8, 24, 22, 56, 11, 32),
                updatedAt: new Date(),
                isBuilt: true
              }
            ]
          },
          {
            id: 48,
            hotelId: 1,
            level: 5,
            paint: 1,
            wallpaper: 1,
            wallpaperTilt: 0,
            createdAt: new Date(2021, 8, 20, 3, 23, 12, 10),
            updatedAt: new Date(),
            rooms: [
              {
                id: 567,
                floorId: 4,
                position: 2,
                type: "special",
                service: SpecialRoomType.POOL,
                createdAt: new Date(2021, 8, 20, 3, 23, 12, 10),
                updatedAt: new Date(),
                isBuilt: true
              },
              {
                id: 865,
                floorId: 4,
                position: 3,
                type: "bed",
                level: 2,
                createdAt: new Date(2021, 8, 21, 4, 12, 32, 11),
                updatedAt: new Date(),
                isBuilt: true
              }
            ]
          }
        ] as any
      }
    });
  }
}
</script>
